C     RELATIVISTIC TWO-BODY KINEMATICS, PRINCETON-TEXAS A&M VERSION
C     COUTESY OF MISS DANNEL TANNER *** COPIED BY HANDS OCT. 21. 1980
C
C     Mass-excess table updated to G.Audi & A.H.Wapstra, NP A595('95)409
C
      COMMON /ENERGY/ AM1,AM2,AM3,AM4,T1,THETA3,EXC,TH3CM,T3,CONVF3,
     * THETA4,T4,CONVF4,THETAM,UNIT,PI,RAD,DEDTH3
      DOUBLE PRECISION AM1,AM2,AM3,AM4,T1,THETA3,EXC,TH3CM,T3,CONVF3,
     *THETA4,T4,CONVF4,THETAM,UNIT,PI,RAD,EXCES,A,AAM4,DEDTH3,TEMP
C     DOUBLE PRECISION DATAN2,DABS,DSIN,DCOS,DSQRT
      DIMENSION STATE(50)
      CHARACTER NAME*30,NA(4)*5,KEY*10
      DATA NZL1/0/,NZL3/0/,KEY/' '/
      UNIT=931.49386
      UNIT1=0.511
      PI=3.141593
      RAD=1.74532925D-2
      C=2.997925D-01
      AMAG=4.25776
      IF (IARGC().NE.0) CALL GETARG(1,KEY)
   12 CONTINUE
C     READ(5,26,END=14) NAME,EBEAM,THMIN,THMAX,DELTH,NSTATE,NZL1,NZL3
C  26 FORMAT(A,4F10.3,3I3)
C  ----------------------------------------------------------------
      WRITE(0,'('' Reaction index, e.g. 12C(d,p)  : '',$)')
      READ(5,'(A)',END=14) NAME
      WRITE(0,'('' Incident total energy (MeV)    : '',$)')
      READ(5,*) EBEAM
      WRITE(0,'('' Min,max,step of angle (degree) : '',$)')
      READ(5,*) THMIN,THMAX,DELTH
      WRITE(0,'('' No. of levels (0 = g.s. only)  : '',$)')
      READ(5,*) NSTATE
C  ----------------------------------------------------------------
      IF(NSTATE.EQ.0) GO TO 103
      WRITE(0,'('' Enter exc. energies ... (MeV)  : '',$)')
      READ(5,*)(STATE(I),I=1,NSTATE)
   27 FORMAT(8F10.5)
      GO TO 104
  103 NSTATE=1
      STATE(1)=0.0
  104 CONTINUE
      IF(DELTH.EQ.0.0) DELTH=5.0
      NANG=(THMAX-THMIN)/DELTH+1.5
      IF(ABS(THMIN).LE.1.E-04.AND.ABS(THMAX).LE.1.E-04) NANG=37
      T1=EBEAM
      CALL DECIFR(NAME,NA)
      CALL MASS(NA(2),EXCES,ERR,MZ,N,*100)
      A=N+MZ
      AM1=A+EXCES/UNIT
      QVALGS=EXCES
      QERROR=ERR**2
      Z1=MZ
      NZ1=MZ
      N4=N
      CALL MASS(NA(1),EXCES,ERR,MZ,N,*100)
      A=N+MZ
      AM2=A+EXCES/UNIT
      QVALGS=QVALGS+EXCES
      QERROR=QERROR+ERR**2
      Z2=MZ
      N4=N4+N
      CALL MASS(NA(3),EXCES,ERR,MZ,N,*100)
      A=N+MZ
      AM3=A+EXCES/UNIT
      QVALGS=QVALGS-EXCES
      QERROE=QERROR+ERR**2
      Z3=MZ
      NZ3=MZ
      N4=N4-N
      L=0
      IF(NA(4).EQ.' ') L=INDEX(NAME,')')+1
      MZ=NINT(Z1+Z2-Z3)
      N=N4
      CALL MASS(NA(4),EXCES,ERR,MZ,N,*100)
      IF(L.NE.0) WRITE(NAME(L:),'(A)') NA(4)
      A=N+MZ
      AM4=A+EXCES/UNIT
      QVALGS=QVALGS-EXCES
      QERROR=SQRT(QERROR+ERR**2)/1000.
      Z4=MZ
      IF(NINT(Z1+Z2-Z3-Z4).NE.0.OR.N4.NE.N) GO TO 105
      BM1=AM1
      BM2=AM2
      BM3=AM3
      BM4=AM4
CCCC  CORRECT FOR ELECTRON MASS
CCCC  IF NOT FULLY STRIPPED, READ IN THE NUMBER OF ELECTRONS LEFT AS NZL
      ZS1=NZ1-NZL1
      ZS3=NZ3-NZL3
      AM1=AM1-ZS1*UNIT1/UNIT
      AM3=AM3-ZS3*UNIT1/UNIT
      AM4=AM4+(ZS3-ZS1)*UNIT1/UNIT
      DEDX1=DEDX(EBEAM,BM1,Z1,BM2,Z2)
      IF (KEY.NE.'-n') THEN
      WRITE(6,3) NAME,AM2,AM1,AM3,AM4
    3 FORMAT(1H1,20X,32H RELATIVISTIC KINEMATICS PROGRAM//24X,A/
     *16X,42H M2   (      M1     ,     M3      )   M4  /10X,F11.6,2H (,
     *F11.6,3H  ,,F11.6,3H  ),F11.6)
      WRITE(6,5) DEDX1,QVALGS,QERROR,EBEAM
    5 FORMAT(14H0DE/DX1 EQUALS,F8.1,11H KEV/MG/CM2,5X,
     *16H QVAL(GS) EQUALS,F8.3,
     *4H  +-,F8.3,5H MEV,5X,7H EBEAM=,F8.3,5H  MEV)
      ENDIF
      DO 4 I=1,NSTATE
      QVAL=QVALGS-STATE(I)
      THRESH=-QVAL*(1.0+AM1/AM2-QVAL/(2.0*AM2*UNIT))
      IF(EBEAM.LE.THRESH) GO TO 101
      IF (KEY.NE.'-n') THEN
      WRITE(6,16) STATE(I)
   16 FORMAT(////18H EXC ENERGY EQUALS,F8.4)
      WRITE(6,6)
    6 FORMAT(10H0 THETA3  ,10H  THETA3  ,10H  KIN EN3 ,10H LAB TO CM,
     *10H  THETA4  ,10H KIN EN4  ,11H DE/DTHETA3,10H  DEDX3   ,10H  OPT
     *TGT ,10H  B-RHO   ,10HFIELD (KG),10H     K    /
     *10H  LAB DEG ,10H  CM DEG  ,10H   (MEV)  ,10H  CONVF3  ,10H LAB DE
     *G  ,10H   (MEV)  ,10H  KEV/DEG ,11H KEV/MG/CM2,10H ANGLE DEG,
     *10H KG-CM    ,11H RHO=240CM ,10H1/P(DP/DT))
      ENDIF
      EXC=STATE(I)
      DO 7 J=1,NANG
      AJ=J
      SAVE=THMIN+(AJ-1.0)*DELTH
      THETA3=SAVE
      AAM4=AM4
      CALL ENOUT(*102)
      AM4=AAM4
      TEMP=1.0+2.0*AM3*UNIT/T3
      AK=(1.0+AM3*UNIT/T3)/(T3*TEMP)*DEDTH3
      AKA=709.44*AK
      DEDTH3=DEDTH3*RAD*1000.
C@@@@ MODIFIED FOR NEUTRON
      BTHO=1.E10
      IF(Z3.NE.0)
     &BRHO=T3*DSQRT(TEMP)/(Z3*C)
      ANU=AMAG*BRHO/90.
      AT3=T3
      DEDX3=DEDX(AT3,BM3,Z3,BM2,Z2)
      AKAP=DEDX3/DEDX1
      IF(DABS(THETA3-0.0).LE.1.D-04.OR.DABS(THETA3-PI).LE.1.D-04) GO TO
     1  15
C     OPT=DATAN((AKAP-DCOS(THETA3))/DSIN(THETA3))
      OPT=DATAN2(AKAP-DCOS(THETA3),DSIN(THETA3))	! to allow 0-degree
   15 IF(DABS(THETA3).LE.1.D-4.OR.DABS(THETA3-PI).LE.1.D-4) OPT=PI/2.0
      OPT=OPT/RAD
      THETA3=THETA3/RAD
      THETA4=THETA4/RAD
C ########################
C  NOT NMR BUR KILO GAUSS
C ########################
C     ANU=BRHO/90.
      ANU=BRHO/240.
C ########################
      WRITE(6,8) THETA3,TH3CM,T3,CONVF3,THETA4,T4,DEDTH3,DEDX3,OPT,
     * BRHO,ANU,AK
    8 FORMAT(F8.2,F8.2,2X,F10.3,F10.4,F10.1,F10.3,3F10.1,1X,F10.3,F10.5,
     1 F10.3)                                                           
c    8 FORMAT(F8.1,F8.1,2X,2F10.3,F10.1,F10.3,3F10.1,1X,F10.3,F10.5,F10.3
c     *)
    7 CONTINUE
      GO TO 4
  102 THETAM=THETAM/RAD
      WRITE(6,10) THETAM
   10 FORMAT(42H MAXIMUM ALLOWED ANGLE FOR PARTICLE EQUALS,F6.1,4H DEG)
    4 CONTINUE
      STOP
C     GO TO 12
  101 WRITE(6,11) THRESH
   11 FORMAT(37H EBEAM IS BELOW REACTION THRESHOLD OF,F8.2,4H MEV)
      GO TO 12
  100 WRITE(6,13) MZ,N
   13 FORMAT(54H1UNDECIPHERABLE SYMBOL OR MASS MISSING FROM MASS TABLE,5
     *X,9H Z EQUALS,I4,2X,9H N EQUALS,I4)
      GO TO 12
  105 WRITE(6,17)
   17 FORMAT(21HINCONSISTENT REACTION)
      GO TO 12
   14 STOP
      END
      SUBROUTINE ENOUT(*)
      COMMON /ENERGY/ AM1,AM2,AM3,AM4,T1,THETA3,EXC,TH3CM,T3,CONVF3,
     * THETA4,T4,CONVF4,THETAM,UNIT,PI,RAD,DEDTH3
      DOUBLE PRECISION AM1,AM2,AM3,AM4,T1,THETA3,EXC,TH3CM,T3,CONVF3,
     *THETA4,T4,CONVF4,THETAM,UNIT,PI,RAD,DEDTH3,E1,EPR2,EPR,RHO,PN,
     *ALPHA3,XC,CTHPR,TH3PR,E3,V2,ALPHA4,E4
C     DOUBLE PRECISION DABS,DATAN2,DSIN,DSQRT,DCOS
      E1=AM1+T1/UNIT
      AM4=AM4+EXC/UNIT
      EPR2=AM1**2+AM2**2+2.0*AM2*E1
      EPR=DSQRT(EPR2)
      RHO=(1.0-(AM3+AM4)**2/EPR2)*(1.0-(AM4-AM3)**2/EPR2)
      PN=DSQRT(1.0-(AM1/E1)**2)
      ALPHA3=(E1/(E1+AM2))*PN*(1.0+(AM3**2-AM4**2)/EPR2)/DSQRT(RHO)
      IF(ALPHA3-1.0) 1,1,2
C   2 THETAM=DATAN(EPR/(E1+AM2)/DSQRT(ALPHA3**2-1.0))
    2 THETAM=DATAN2(EPR,(E1+AM2)*DSQRT(ALPHA3**2-1.0))	! to allow 0-degree
      GO TO 3
    1 THETAM=PI
    3 THETA3=THETA3*RAD
      IF(THETA3.GT.THETAM) RETURN1
      IF(DABS(THETA3-0.0).LE.1.D-04) GO TO 4
      IF(DABS(THETA3-PI/2.).LE.1.D-04) GO TO 5
      IF(DABS(THETA3-PI).LE.1.D-04) GO TO 7
      IF(THETA3.GT.PI/2.) SGN=-1.0
      IF(THETA3.LE.PI/2.) SGN=1.0
      XC=(EPR2/(E1+AM2)**2)*(1.0/((DSIN(THETA3)/DCOS(THETA3))**2))
      CTHPR=-(ALPHA3/(1.0+XC))+SGN*DSQRT((XC/(1.0+XC))*(1.0-ALPHA3**2/
     * (1.0+XC)))
      GO TO 6
    4 CTHPR=1.0
      GO TO 6
    5 CTHPR=-ALPHA3
      GO TO 6
    7 CTHPR=-1.0
C   6 TH3PR=PI/2.0-DATAN(CTHPR/DSQRT(1.0-CTHPR**2))
    6 TH3PR=PI/2.0-DATAN2(CTHPR,DSQRT(1.0-CTHPR**2))	! to allow 0-degree
      TH3CM=TH3PR/RAD
      E3=(E1/2.0)*((1.+AM2/E1)*(1.0+(AM3**2-AM4**2)/EPR2)+DSQRT(RHO)*PN*
     * CTHPR)
      T3=(E3-AM3)*UNIT
      V2=PN**2/(1.0+AM2/E1)**2
      CONVF3=(EPR2/(E3**2-AM3**2))*DSQRT(1.0-(ALPHA3**2-V2)/(1.0-V2)
     *  *DSIN(THETA3)**2)*0.25*RHO
      DEDTH3=0.0
      IF(DABS(THETA3-0.0).LE.1.D-4.OR.DABS(THETA3-PI).LE.1.D-4) GO TO 10
      IF(DABS(CTHPR*ALPHA3+1.).LE.1.D-06) GO TO 10
      DEDTH3=DABS(E1*PN*DSQRT(RHO)*DSIN(TH3PR)**3/(2.0*DSIN(THETA3)**2)/
     * (1.0+ALPHA3*CTHPR))*EPR/(E1+AM2)*UNIT
   10 ALPHA4=(E1/(E1+AM2))*PN*(1.0+(AM4**2-AM3**2)/EPR2)/DSQRT(RHO)
      IF(DABS(ALPHA4-CTHPR).LE.1.D-04) GO TO 8
C     THETA4=DATAN((DSQRT(EPR2)/(E1+AM2))*DSIN(TH3PR)/(CTHPR-ALPHA4))
      THETA4=DATAN2(DSQRT(EPR2)*DSIN(TH3PR),(E1+AM2)*(CTHPR-ALPHA4)) ! 0-degree
      GO TO 9
    8 THETA4=PI/2.0
    9 CONTINUE
      E4=(E1/2.0)*((1.+AM2/E1)*(1.0+(AM4**2-AM3**2)/EPR2)-DSQRT(RHO)*PN*
     * CTHPR)
      T4=(E4-AM4)*UNIT
      IF (T4.NE.0.)
     *CONVF4=(EPR2/(E4**2-AM4**2))*DSQRT(1.0-(ALPHA4**2-V2)/(1.0-V2)
     **DSIN(THETA4)**2)*0.25*RHO
      RETURN
      END
      FUNCTION DEDX(EINC,AMINC,ZINC,AMTARG,ZTARG)
CCCC
C    CALCULATES THE STOPPING POWER OF CHEMICAL ELEMENTS FOR CHARGED PAR-
C    TICLES.  EINC IS THE ENERGY OF THE INCIDENT PARTICLE (MEV).  AMIN
C    IS THE MASS OF THE INCIDENT PARTICLE (AMU).  ZINC IS THE ATOMIC
C    NUMBER OF THE INCIDENT PARTICLE.  AMTARG IS THE MASS OF THE TARGET
C    ELEMENT (AMU).  ZTARG IS THE ATOMIC NUMBER OF THE TARGET MATERIAL.
C    DEDX RETURNS AS THE VALUE OF THE STOPPING POWER IN UNITS OF
C    MEV*CM**2/G
C    THE SUBROUTINE USES THE ALGORITHM OF WILLIAMSON, BOUJOT, AND
C    PICARD.  AS EXPOUNDED IN THEIR RAPPORT CEA-R 3042 'TABLES OF RANGE
C    AND STOPPING POWER OF CHEMICAL ELEMENTS FOR CHARGED PARTICLES OF
C    ENERGY 0.05 TO 200 MEV'
CCCC
      DATA AMU,RPIBY2/931.504,1.253314/
C@@@@ MODIFIED FOR NEUTRON
      DEDX=0.
      IF(ZINC.EQ.0.) RETURN
      IF(EINC.LE.0.) GO TO 3
      GRUN=AMINC*AMU+EINC
      BETA=(SQRT(GRUN**2-(AMINC*AMU)**2))/GRUN
      BET2=BETA**2
      IF(BET2.LE.0.) GO TO 3
      ZIN=ZINC*TANH(137.0388*RPIBY2*BETA/ZINC)
      QPA=1835.*AMINC
      QPB=QPA/(1.0+QPA)
      QMAX=(1.022*BET2)/(1.0-BET2)*QPB*QPB
      QMAX=QMAX/(1.0+(2.0*QPB*EINC/(QPA*AMINC*AMU)))
      AI=ZTARG**(-0.6666667)-8.33/(ZTARG**2)+26.04/(ZTARG**3)-18.384/
     &  (ZTARG**4)
      AI=EXP(AI)
      GLUB=-100.0/EINC
      IF(GLUB.LE.-20.) GO TO 1
      AI=AI*11.8E-6*ZTARG*(1.-0.25*EXP(GLUB))
      GO TO 2
    1 AI=AI*11.8E-6*ZTARG
    2 CONTINUE
      RHO=1.0+0.035*(ZIN**1.5+SQRT(ZTARG))
      AE=SQRT(1.022*BET2*QMAX/(1.0-BET2))/AI
      GLUB=-((AE)**(1./RHO))
      IF(GLUB.LT.-20.) GO TO 4
      DEDX=ALOG(AE/((1.-EXP(GLUB))**RHO))
      DEDX=DEDX-BET2
      GO TO 5
    4 DEDX=ALOG(AE)-BET2
    5 CONTINUE
      DEDX=0.30711*ZTARG*(ZIN**2)*DEDX/(AMTARG*BET2)
      RETURN
    3 DEDX=0.0
      RETURN
      END
      SUBROUTINE DECIFR(NAME,NA)
C A PROGRAM WHICH IDENTIFIES ( AND , AND ).  NA1 - NA4 ARE NUCLEAR SYMBO
C EXAMPLE 197AU.  THEY CAN BE A SERIES OF BLANKS.
      CHARACTER NAME*(*),NA(4)*(*),LP(4)
      DATA(LP(J),J=1,4)/'(',',',')',' '/
      DO 10 I=1,4
   10 NA(I)=LP(4)
      I1=1
      DO 1 I=1,4
      J1=1
    2 DO 6 J=I1,LEN(NAME)
      IF(NAME(J:J).EQ.LP(I).AND.I.NE.4) GO TO 1
      IF(NAME(J:J).EQ.LP(4)) GO TO 6
      NA(I)(J1:J1)=NAME(J:J)
      J1=J1+1
    6 CONTINUE
    1 I1=J+1
      RETURN
      END
